"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.convertPriceToSqrtX96 = exports.convertSqrtX96toPrice = void 0;
const index_js_1 = require("../abi/index.js");
async function convertSqrtX96toPrice(publicClient, tokens, sqrtPriceX96) {
    let token0;
    let token1;
    if (tokens[0].toLowerCase() < tokens[1].toLowerCase()) {
        token0 = tokens[0];
        token1 = tokens[1];
    }
    else {
        token0 = tokens[1];
        token1 = tokens[0];
    }
    const decimal0 = await publicClient.readContract({
        abi: index_js_1.ERC20_ABI,
        address: token0,
        functionName: "decimals",
    });
    const decimal1 = await publicClient.readContract({
        abi: index_js_1.ERC20_ABI,
        address: token1,
        functionName: "decimals",
    });
    const sqrtPrice = sqrtPriceX96 / 2 ** 96;
    const price = sqrtPrice ** 2;
    const adjustedPrice = 10 ** decimal1 / (price * 10 ** decimal0);
    return adjustedPrice;
}
exports.convertSqrtX96toPrice = convertSqrtX96toPrice;
async function convertPriceToSqrtX96(publicClient, tokens, price) {
    let token0;
    let token1;
    if (tokens[0].toLowerCase() < tokens[1].toLowerCase()) {
        token0 = tokens[0];
        token1 = tokens[1];
    }
    else {
        token0 = tokens[1];
        token1 = tokens[0];
    }
    const decimal0 = await publicClient.readContract({
        abi: index_js_1.ERC20_ABI,
        address: token0,
        functionName: "decimals",
    });
    const decimal1 = await publicClient.readContract({
        abi: index_js_1.ERC20_ABI,
        address: token1,
        functionName: "decimals",
    });
    const normalizedPrice = 10 ** decimal1 / (price * 10 ** decimal0);
    const sqrtPrice = Math.sqrt(normalizedPrice);
    const sqrtPriceX96 = sqrtPrice * 2 ** 96;
    return sqrtPriceX96;
}
exports.convertPriceToSqrtX96 = convertPriceToSqrtX96;
//# sourceMappingURL=uniswapV3.js.map